diff --git a/contrib/ncurses/announce.html.in b/contrib/ncurses/announce.html.in
index 84b9d4297de5..9889ef1bfb6c 100644
--- a/contrib/ncurses/announce.html.in
+++ b/contrib/ncurses/announce.html.in
@@ -1136,248 +805,165 @@
   <p>There are no new manual pages (all of the manual page updates
   are to existing pages).</p>
 
-  <p>Some of the improvements are more subtle, relating to the way
-  the information is presented. For instance, the generated
-  terminfo.5 file uses a different table layout, allowing it to use
-  space on wide terminals more effectively.</p>
-
   <h3><a name="h3-bug-fixes" id="h3-bug-fixes">Interesting
   bug-fixes</a></h3>
 
-  <p>While there were many bugs fixed during development of ncurses
-  6.2, only a few (the reason for this release) were both important
-  and interesting. Most of the bug-fixes were for local issues
-  which did not affect compatibility across releases. Since those
-  are detailed in the NEWS file no elaboration is needed here.</p>
-
-  <p>The interesting bugs were in tic/infocmp's handling of
-  user-defined capabilities. These were not recent bugs. Initially
-  it was a simple problem:</p>
+  <p>The changes to <tt>tparm</tt>, <tt>tgoto</tt> which improve
+  the design of the low-level interfaces are <em>interesting</em>,
+  but are not bug-fixes <em>per se</em>.</p>
 
-  <ul>
-    <li>The user-defined capabilities can be any type (boolean,
-    number or string), but once given a type all uses of the name
-    must conform to that type&mdash;unless some special support for
-    a particular multi-typed name is built into ncurses.</li>
+  <h3><a name="h3-config-config" id=
+  "h3-config-config">Configuration changes</a></h3>
 
-    <li>
-      <p>One of simpleterm's contributors copied some definitions
-      for using <em>tmux</em>'s user-defined capabilities in
-      <a href=
-      "https://git.suckless.org/st/commit/06f8cf8ca87a81db15816658c40b2afcd1ad5332.html">
-      late in 2016</a>.</p>
+  <h4><a name="h4-config-major" id="h4-config-major">Major
+  changes</a></h4>
 
-      <blockquote>
-        <pre class="demo-name">
-diff --git a/st.info b/st.info
-@@ -185,7 +185,10 @@ st| simpleterm,
-  tsl=\E]0;,
-  xenl,
-  vpa=\E[%i%p1%dd,
--
-+# Tmux unofficial extensions, see TERMINFO EXTENSIONS in tmux(1)
-+ Se,
-+ Ss,
-+ Tc,
- 
- st-256color| simpleterm with 256 colors,
-  use=st,
-</pre>
-      </blockquote>
-    </li>
+  <p>These are the major changes (aside from introducing <a href=
+  "#h4-new-library"><tt>tiparm_s</tt></a>):</p>
 
+  <ul>
     <li>
-      <p>Later, in (referring to a version from <a href=
-      "https://git.suckless.org/st/commit/c0882f2ed1d7a2dd0fa2efa52157e6fc6fde3652.html">
-      mid-2017</a>), a user asked to have it updated in
-      ncurses.</p>
+      <p>use wide-character (ncursesw) by default</p>
     </li>
 
     <li>
-      <p>However, it had an error from the change in late 2016. The
-      terminal description made what <em>tmux</em> expected to be
-      <strong>string</strong> actually a
-      <strong>boolean</strong>.</p>
-
-      <p>Over the years, there were problems with each of
-      simpleterm's terminal descriptions. I repaired those, and
-      usually dealt with the problem.</p>
+      <p>use opaque typedefs by default</p>
     </li>
+  </ul>
+
+  <p>However, most of the work on configure scripts was done to
+  reduce warnings within the configure script:</p>
 
+  <ul>
     <li>
-      <p>The difference in this case was that when compiling the
-      terminal database, <em>tic</em> may have in memory the
-      definitions for more than one terminal description (so that
-      it can resolve &ldquo;<tt>use=</tt>&rdquo; clauses). Seeing
-      two different types for the same name, in certain situations
-      it would incorrectly merge the symbol tables for the two
-      terminal descriptions.</p>
+      <p>intrusive warnings from GNU grep regarding fgrep and
+      egrep</p>
     </li>
 
     <li>
-      <p>On simpleterm's side, their bug was finally fixed in
-      <a href=
-      "https://git.suckless.org/st/commit/83866428de031300eab03fbb116bcf7d2b1d4f60.html">
-      late 2019</a>, three years after the bug was created.</p>
+      <p>fatal errors in compile-checks, arising from recent
+      &ldquo;Modern&nbsp;C&rdquo; efforts by some developers which
+      caused longstanding configure checks to fail.</p>
+
+      <p>After repairing the configure script, none of that
+      activity affected ncurses because stricter warnings are used
+      routinely in development.</p>
     </li>
   </ul>
 
-  <p>For ncurses, the elapsed time to fix this bug was less than
-  three years. Someone reported a problem with the terminal
-  description a few weeks after releasing ncurses 6.1 (in <a href=
-  "https://github.com/tmux/tmux/issues/1264">tmux #1264</a>), and
-  the terminal description was updated that week (ncurses patch
-  <a href="@HOMEPAGE@/NEWS.html#t20180224">20180224</a>):</p>
-
-  <blockquote>
-    <pre class="demo-name">
-20180224
-        + modify _nc_resolve_uses2() to detect incompatible types when merging
-          a "use=" clause of extended capabilities.  The problem was seen in a
-          defective terminfo integrated from simpleterm sources in 20171111,
-          compounded by repair in 20180121.
-        + correct Ss/Ms interchange in st-0.7 entry (tmux #1264) -TD
-</pre>
-  </blockquote>
-
-  <p>The larger part of that change added a check to prevent a
-  simple merge of terminal descriptions where the same user-defined
-  name was used with different types. But it raised some
-  questions:</p>
+  <p>Other improvements made to configure checks include</p>
 
   <ul>
     <li>
-      <p>Was there a reliable way to manage terminal descriptions
-      which used the same extended name in different ways?</p>
+      <p>use <a href=
+      "@HOMEPAGE@/INSTALL.html#option:enable-string-hacks">string-hacks</a>
+      in alloc_entry.c, alloc_type.c and hardscroll.c, overlooked
+      due to compiler changes in recent OpenBSD releases</p>
     </li>
 
     <li>
-      <p>Should ncurses provide a registry of well-known extended
-      names, with their types?</p>
+      <p>revise progs.priv.h to provide for NC_ISATTY reuse</p>
     </li>
-  </ul>
-
-  <p>Since the correction to <a href=
-  "@HOMEPAGE@/ncurses.html#download_database"><tt>terminfo.src</tt></a>
-  could have been readily adopted by packagers, there was nothing
-  more to be done from ncurses' standpoint on that part. But
-  improving ncurses to prevent issues like that is the reason for
-  making a release.</p>
 
-  <p>Nothing more (constructive) was mentioned with regard to
-  simpleterm. But a few problems were found in the handling of
-  user-defined capabilities:</p>
+    <li>
+      <p>configure check for MB_LEN_MAX provides warning as
+      needed</p>
+    </li>
 
-  <ul>
     <li>
-      <p>Forward-references to user-defined capabilities in a
-      &ldquo;<tt>use=</tt>&rdquo; clause did not allocate new data
-      for each use. In <em>tic</em>, successive compilation of
-      terminal entries could add user-defined capabilities to the
-      wrong terminal entry.</p>
+      <p>trim a space after some "-R" options, fixing builds for
+      applications built using clang and ncurses on Solaris</p>
+    </li>
 
-      <p>This was not noticed before, since xterm's terminal
-      descriptions were the main users of the feature, and almost
-      all of the uses of the building-blocks which contained
-      user-defined capabilities were backward-references.</p>
+    <li>
+      <p>work around misconfiguration of MacPorts gcc13, which
+      exposes invalid definition of <tt>MB_LEN_MAX</tt> in gcc's
+      fallback copy of <tt>limits.h</tt></p>
     </li>
 
     <li>
-      <p>There is one (documented) case where ncurses 6.1 supports
-      a user-defined capability that could be any type (i.e.,
-      &ldquo;RGB&rdquo;). The check added in February 2018 to guard
-      against mismatches did not handle all of the combinations
-      needed.</p>
+      <p>modified experimental Windows driver works with xterm
+      mouse protocol</p>
     </li>
   </ul>
 
-  <p>Both of these issues dated from the original implementation of
-  user-defined capabilities. Fixing them does not change the
-  terminal database, but a older <em>tic</em> without the fixes
-  will not be able to handle terminfo sources which rely upon those
-  fixes. Starting in June 2019, the download link for the terminfo
-  source file was capped at that date. The development sources have
-  an up-to-date copy of the file, for people with a legitimate need
-  for it.</p>
-
-  <p>The &ldquo;<tt>-c</tt>&rdquo; (check) option of <em>tic</em>
-  is not very useful if it cannot offer advice on parameters needed
-  for user-defined capabilities. The various <em>Caps</em> files
-  were reorganized to reduce redundancy, and in the common portion
-  (<a href=
-  "https://github.com/ThomasDickey/ncurses-snapshots/blob/master/include/Caps-ncurses">Caps-ncurses</a>),
-  a registry of user-defined capabilities is provided for use by
-  <em>tic</em>. While users can still define their own custom
-  capabilities, <em>tic</em> will not offer any advice when their
-  parameters do not match.</p>
-
-  <p>In ncurses 6.2, <em>tic</em> makes a special check to allow
-  any type for <em>RGB</em>, but its being able to do this relies
-  upon fixes made in the ncurses library in mid-2019.</p>
-
-  <h3><a name="h3-config-config" id=
-  "h3-config-config">Configuration changes</a></h3>
-
-  <h4><a name="h4-config-major" id="h4-config-major">Major
-  changes</a></h4>
-
-  <p>There are no major changes. Several new options were added to
-  ease integration of packages with systems using different
-  versions of <em>GNAT</em> and <em>ncurses</em>. Also,
-  improvements were made to configure checks.</p>
-
   <h4><a name="h4-config-options" id=
   "h4-config-options">Configuration options</a></h4>
 
-  <p>There are a few new/modified configure options:</p>
+  <p>There are a few new configure options:</p>
 
   <dl>
-    <dt><tt>--with-config-suffix</tt>
+    <dt><a href=
+    "@HOMEPAGE@/INSTALL.html#option:disable-setuid-environ"><tt>--disable-setuid-environ</tt></a>
     </dt>
 
     <dd>
-      <p>helps work around a filename conflict with Debian packages
-      versus test-packages.</p>
+      <p>Compile with environment restriction, so certain
+      environment variables are not available when running via a
+      setuid/setgid application. These are (for example
+      <tt>$TERMINFO</tt>) those that allow the search path for the
+      terminfo or termcap entry to be customized.</p>
+
+      <p>A setuid/setgid application inherits its environment
+      variables from the current user, in contrast to sudo which
+      may limit the environment variables that ncurses uses.</p>
     </dd>
 
-    <dt><tt>--with-ada-libname</tt>
+    <dt><a href=
+    "@HOMEPAGE@/INSTALL.html#option:enable-check-size"><tt>--enable-check-size</tt></a>
     </dt>
 
     <dd>
-      <p>allows one to rename the &ldquo;AdaCurses&rdquo; library
-      (at least one packager prefers a lowercase name).</p>
+      <p>Compile-in feature to detect screensize for terminals
+      which do not advertise their screensize, e.g., serial
+      terminals.</p>
     </dd>
 
-    <dt><tt>--with-fallbacks</tt>
+    <dt><a href=
+    "@HOMEPAGE@/INSTALL.html#option:with-abi-altered"><tt>--with-abi-altered=<em>NUM</em></tt></a>
     </dt>
 
     <dd>
-      <p>now ensures there is a value, and adds the fallback
-      information to top-level Makefile summary.</p>
+      <p>Override the displayed (rather than compiled-in) ABI. Only
+      packagers who have created configurations where the ABI
+      differs from ncurses should be interested in this option.</p>
     </dd>
 
-    <dt><tt>--with-pcre2</tt>
+    <dt><a href=
+    "@HOMEPAGE@/INSTALL.html#option:with-strip-program"><tt>--with-strip-program=<em>XXX</em></tt></a>
     </dt>
 
     <dd>
-      <p>check for pcre-posix library to help with MinGW port.</p>
+      <p>When stripping executables during install, use the
+      specified program rather than &ldquo;strip&rdquo; overriding
+      program chosen by the install program for stripping
+      executables.</p>
     </dd>
+  </dl>
 
-    <dt><tt>--with-tic-path</tt> and<br></dt>
+  <p>These configure options are modified:</p>
 
-    <dt><tt>--with-infocmp-path</tt>
+  <dl>
+    <dt><a href=
+    "@HOMEPAGE@/INSTALL.html#option:with-pkg-config-libdir"><tt>--with-pkg-config-libdir[=<em>DIR</em>]</tt></a>
     </dt>
 
     <dd>
-      <p>help work around problems building fallback source using
-      pre-6.0 tic/infocmp.</p>
+      <p>The optional <em>DIR</em> parameter can now be
+      &ldquo;auto&rdquo; to automatically use pkg-config's library
+      directory.</p>
+
+      <p>The default is <tt>$(libdir)</tt>.</p>
     </dd>
 
-    <dt><tt>--with-versioned-syms</tt>
+    <dt><a href=
+    "@HOMEPAGE@/INSTALL.html#option:with-xterm-kbs"><tt>--with-xterm-kbs[=<em>XXX</em>]</tt></a>
     </dt>
 
     <dd>
-      <p>option value can now be a relative pathname.</p>
+      <p>The default is &ldquo;auto&rdquo; which tells the
+      configure script to choose BS or DEL according to platform
+      defaults.</p>
     </dd>
   </dl>
 
@@ -1388,148 +974,117 @@ diff --git a/st.info b/st.info
 
   <ul>
     <li>
-      <p>ignore <a href=
-      "/ncurses/man/ncurses.3x.html#h3-TERMINFO"><tt>$TERMINFO</tt></a>
-      as a default value in configure script if it came from the
-      <tt>infocmp</tt> <strong><tt>-Q</tt></strong> option.</p>
+      <p>add/use configure check for <code>clock_gettime</code>, to
+      supersede <code>gettimeofday</code>.</p>
     </li>
 
     <li>
-      <p>distinguish gcc from icc and clang when the
-      <tt>--enable-warnings</tt> option is not used, to avoid
-      unnecessary warnings about unrecognized inline options</p>
+      <p>modify configure script check for pkg-config library
+      directory to take into account an older version 0.15.0 which
+      used PKG_CONFIG_PATH but not PKG_CONFIG_LIBDIR</p>
     </li>
 
     <li>
-      <p>consistently prepend new libraries as they are found
-      during configuration, rather than relying upon the linker to
-      resolve order dependencies of libraries.</p>
+      <p>allow for MinGW32-/64-bit configurations to use
+      _DEFAULT_SOURCE</p>
     </li>
 
     <li>
-      <p>modified configure scripts to reduce relinking/ranlib
-      during library install :</p>
-
-      <ul>
-        <li>use &ldquo;<tt>install -p</tt>&rdquo; when available,
-        to avoid need for ranlib of static libraries.</li>
-
-        <li>scripts which use
-        &ldquo;<tt>--disable-relink</tt>;&rdquo; add a 1-second
-        sleep to work around tools which use whole-second
-        timestamps, e.g., in <tt>utime</tt> rather than the actual
-        file system resolution.</li>
-      </ul>
+      <p>modify CF_XOPEN_SOURCE macro's amend default case to avoid
+      undefining _XOPEN_SOURCE if _POSIX_C_SOURCE is defined</p>
     </li>
 
     <li>
-      <p id="getenv-check">add configure check for <a href=
-      "#getenv-fixes"><tt>getenv</tt></a> to work around
-      implementation shown in Emscripten which overwrites the
-      previous return value on each call.</p>
-
-      <p>Use that to optionally suppress <tt>START_TRACE</tt>
-      macro, whose call to <tt>getenv</tt> may not work
-      properly</p>
+      <p>updated configure script macro CF_XOPEN_SOURCE, for
+      uClibc-ng</p>
     </li>
 
     <li>
-      <p>change target configure level for <tt>_XOPEN_SOURCE</tt>
-      to 600 to address use of <tt>vsscanf</tt> and
-      <tt>setenv</tt>.</p>
+      <p>modify version-check for gcc/g++, now works for msys2</p>
     </li>
 
     <li>
-      <p>reduce use of <tt>_GNU_SOURCE</tt> for current glibc where
-      <tt>_DEFAULT_SOURCE</tt> combines with
-      <tt>_XOPEN_SOURCE</tt></p>
+      <p>build-fixes related to configure-options and/or
+      platform:</p>
 
-      <p>Allow for Cygwin's newlib when checking for the
-      _DEFAULT_SOURCE symbol.</p>
+      <ul>
+        <li>fix for <tt>--enable-fvisibility</tt></li>
 
-      <p>MidnightBSD is now checked for the
-      <tt>_XOPEN_SOURCE</tt>-related definitions.</p>
-    </li>
+        <li>fix for unusual values of
+        <tt>--with-rel-version</tt></li>
 
-    <li>
-      <p>If the check for <tt>va_copy</tt> or <tt>__va_copy</tt>
-      fails,</p>
+        <li>fix for unusual values of
+        <tt>--with-abi-version</tt></li>
 
-      <ul>
-        <li>configure now tries copying the pointers for
-        <tt>va_list</tt>, or as an array.</li>
+        <li>fix for <tt>--disable-tcap-names</tt></li>
 
-        <li>alternatively, it checks for
-        <tt>__builtin_va_copy</tt>(), which could be used with AIX
-        <tt>xlc</tt> in <em>c89</em> mode.</li>
+        <li>fix for termcap in <tt>nc_access.h</tt></li>
       </ul>
     </li>
 
     <li>
-      <p>several changes to support a port to Ultrix 3.1:</p>
+      <p>other configure-script improvements:</p>
 
       <ul>
-        <li>check if "b" binary feature of fopen works</li>
+        <li>recent msys2 headers work with
+        <tt>_DEFAULT_SOURCE</tt>; amend check</li>
 
-        <li>check for missing feature of locale.h</li>
+        <li>use <tt>$ac_includes_default</tt> in most cases where
+        stdlib.h should work</li>
 
-        <li>add fallback for strstr() in test-programs</li>
+        <li>use <tt>#error</tt> consistently vs "make an
+        error"</li>
 
-        <li>add fallback for STDOUT_FILENO in test-programs</li>
+        <li>add configure macro for <tt>gettimeofday</tt> vs inline
+        check</li>
       </ul>
     </li>
+  </ul>
 
-    <li>
-      <p>The <em>test/configure</em> script (used for <a href=
-      "/ncurses/ncurses-examples.html"><em>ncurses-examples</em></a>)
-      is improved:</p>
-
-      <ul>
-        <li>work around non-ncurses termcap.h file, e.g., in
-        Slackware.</li>
+  <p>Here are some of the other portability fixes:</p>
 
-        <li>check for <a href=
-        "/ncurses/man/curs_variables.3x.html#h3-TABSIZE"><tt>TABSIZE</tt></a>
-        variable.</li>
+  <ul>
+    <li>
+      <p>modify configure scripts/makefiles to omit
+      <tt>KEY_RESIZE</tt> if the corresponding <tt>SIGWINCH</tt>
+      feature is disabled</p>
+    </li>
 
-        <li>checks for the X11/Intrinsic.h header, accommodate
-        recent MacOS changes which largely emptied
-        <tt>/usr/include</tt>.</li>
-      </ul>
+    <li>
+      <p>increase <tt>MB_CUR_MAX</tt> to 16, matching glibc's
+      <tt>MB_LEN_MAX</tt></p>
     </li>
-  </ul>
 
-  <p>Here are some of the other portability fixes:</p>
+    <li>
+      <p>add BSD <tt>erase2</tt> to characters handled by
+      tset/reset</p>
+    </li>
 
-  <ul>
     <li>
-      <p>added dummy "check" rule in top-level and test-Makefile to
-      simplify building test-packages for ArchLinux.</p>
+      <p>use <tt>getauxval</tt> when available, to improve
+      <tt>setuid</tt>/<tt>setgid</tt> checks</p>
     </li>
 
     <li>
-      <p>dropped library-dependency on psapi for MinGW port, since
-      win_driver.c defines <tt>PSAPI_VERSION</tt> to 2, making it
-      use <tt>GetProcessImageFileName</tt> from kernel32.dll</p>
+      <p>set <tt>dwShareMode</tt> in calls to
+      <tt>CreateConsoleScreenBuffer</tt></p>
     </li>
 
     <li>
-      <p>made build-fixes for configuration using --program-suffix
-      with Ada95, noticed with MacOS but applicable to other
-      platforms without libpanelw, etc.</p>
+      <p>use <tt>CreateFile</tt> with "<tt>CONIN$</tt>",
+      "<tt>CONOUT$</tt>" rather than <tt>GetStdHandle</tt> to
+      obtain a handle on the actual console, avoiding redirection
+      in the MinGW/Win32 configurations</p>
     </li>
 
     <li>
-      <p>modified ncurses/Makefile.in to fix a case where
-      Debian/testing changes to the ld --as-needed configuration
-      broke ncurses-examples test packages.</p>
+      <p>modify MinGW driver to return <tt>KEY_BACKSPACE</tt> when
+      an unmodified <tt>VK_BACK</tt> virtual key is entered</p>
     </li>
 
     <li>
-      <p>used <tt>_WIN32</tt>/<tt>_WIN64</tt> in preference to
-      <tt>__MINGW32__</tt>/<tt>__MINGW64__</tt> symbols to simplify
-      building with Microsoft Visual C++, since the former are
-      defined in both compiler configurations.</p>
+      <p>modify MinGW configuration to provide for running in
+      MSYS/MSYS2 shells, assuming ConPTY support</p>
     </li>
   </ul>
 
@@ -1548,30 +1103,31 @@ diff --git a/st.info b/st.info
     </li>
 
     <li>
-      <p><span class="main-name">ncurses</span> supports all of the
-      for SVr4 curses features including keyboard mapping, color,
-      forms-drawing with ACS characters, and automatic recognition
+      <p><span class="main-name">ncurses</span> supports the
+      features of SVr4 curses including keyboard mapping, color,
+      form drawing with ACS characters, and automatic recognition
       of keypad and function keys.</p>
     </li>
 
     <li>
-      <p><span class="main-name">ncurses</span> provides these SVr4
-      add-on libraries (not part of X/Open Curses):</p>
+      <p><span class="main-name">ncurses</span> provides work-alike
+      replacements of SVr4 supplemental libraries based on curses,
+      but which were not specified by X/Open Curses:</p>
 
       <ul>
         <li>
-          <p>the panels library, supporting a stack of windows with
-          backing store.</p>
+          <p>the panel library, supporting a stack of windows with
+          backing store</p>
         </li>
 
         <li>
-          <p>the menus library, supporting a uniform but flexible
-          interface for menu programming.</p>
+          <p>the menu library, supporting a uniform but flexible
+          interface for menu programming</p>
         </li>
 
         <li>
           <p>the form library, supporting data collection through
-          on-screen forms.</p>
+          on-screen forms</p>
         </li>
       </ul>
     </li>
@@ -1583,7 +1139,7 @@ diff --git a/st.info b/st.info
       <ul>
         <li>
           <p><span class="main-name">ncurses</span> supports
-          user-defined capabilities which it can see, but which are
+          user-defined capabilities that it can see, but which are
           hidden from SVr4 curses applications using the
           <em>same</em> terminal database.</p>
         </li>
@@ -1605,7 +1161,7 @@ diff --git a/st.info b/st.info
       <p>The <span class="main-name">ncurses</span> utilities have
       options to allow you to filter terminfo entries for use with
       less capable <em>curses</em>/<em>terminfo</em> versions such
-      as the HP/UX and AIX ports.</p>
+      as the HP-UX and AIX ports.</p>
     </li>
   </ul>
 
@@ -1615,11 +1171,11 @@ diff --git a/st.info b/st.info
   <ul>
     <li>
       <p>The API is 8-bit clean and base-level conformant with the
-      X/OPEN curses specification, XSI curses (that is, it
-      implements all BASE level features, and most EXTENDED
-      features). It includes many function calls not supported
-      under SVr4 curses (but portability of all calls is documented
-      so you can use the SVr4 subset only).</p>
+      X/Open Curses specification, XSI curses (that is, it
+      implements all <em>BASE</em> level features, and almost all
+      <em>EXTENDED</em> features). It includes many function calls
+      not supported under SVr4 curses (but portability of all calls
+      is documented so you can use the SVr4 subset only).</p>
     </li>
 
     <li>
@@ -1661,6 +1217,11 @@ diff --git a/st.info b/st.info
       than one control sequence to map to a given key code.</p>
     </li>
 
+    <li>
+      <p>Support for direct-color terminals, such as modern
+      xterm.</p>
+    </li>
+
     <li>
       <p>Support for 256-color terminals, such as modern xterm.</p>
     </li>
@@ -1751,10 +1312,27 @@ diff --git a/st.info b/st.info
     </li>
 
     <li>
-      <p>The library meets the XSI requirement that every macro
-      entry point have a corresponding function which may be linked
-      (and will be prototype-checked) if the macro definition is
-      disabled with <code>#undef</code>.</p>
+      <p>X/Open Curses permits most functions it specifies to be
+      made available as macros as well. ncurses does this</p>
+
+      <ul>
+        <li>to improve performance, e.g., for operations composed
+        of simpler functions such as cursor movement following by
+        adding text to the screen,</li>
+
+        <li>to simplify the implementation by reusing functions
+        which use common parameters, e.g., the standard screen
+        <code>stdscr</code>, and</li>
+
+        <li>to provide functions that return values via their
+        parameters</li>
+      </ul>
+
+      <p>Except for the last case, ncurses provides a non-macro
+      implementation of the function. If the macro definition is
+      disabled with <code>#undef</code>, or by defining
+      <code>NCURSES_NOMACROS</code> the function may be linked (and
+      its calls will be checked against the prototype).</p>
     </li>
 
     <li>
@@ -1856,7 +1434,8 @@ diff --git a/st.info b/st.info
         <p>New vi uses ncurses.</p>
 
         <p><a href=
-        "https://sites.google.com/a/bostic.com/keithbostic/vi">https://sites.google.com/a/bostic.com/keithbostic/vi</a><br>
+        "https://sites.google.com/a/bostic.com/keithbostic/the-berkeley-vi-editor-home-page">
+        https://sites.google.com/a/bostic.com/keithbostic/the-berkeley-vi-editor-home-page</a><br>
 
         </p>
       </dd>
@@ -1904,7 +1483,7 @@ diff --git a/st.info b/st.info
         <p>terminal emulator for serial modem connections</p>
 
         <p><a href=
-        "https://alioth.debian.org/projects/minicom/">https://alioth.debian.org/projects/minicom/</a></p>
+        "https://salsa.debian.org/minicom-team/minicom">https://salsa.debian.org/minicom-team/minicom</a></p>
       </dd>
 
       <dt><span class="part-name">mosh</span>
@@ -1913,8 +1492,7 @@ diff --git a/st.info b/st.info
       <dd>
         <p>a replacement for <code>ssh</code>.</p>
 
-        <p><a href=
-        "https://mosh.mit.edu/">https://mosh.mit.edu/</a></p>
+        <p><a href="https://mosh.org/">https://mosh.org/</a></p>
       </dd>
 
       <dt><span class="part-name">tack</span>
@@ -2005,7 +1583,7 @@ diff --git a/st.info b/st.info
   <p>Ongoing development work is done by <a href=
   "mailto:dickey@invisible-island.net">Thomas E. Dickey</a>. Thomas
   E. Dickey has acted as the maintainer for the Free Software
-  Foundation, which holds a <a href=
+  Foundation, which held a <a href=
   "@HOMEPAGE@/ncurses-license.html">copyright on ncurses</a> for
   releases 4.2 through 6.1. Following the release of ncurses 6.1,
   effective as of release 6.2, copyright for ncurses reverted to
@@ -2026,7 +1604,6 @@ diff --git a/st.info b/st.info
     "mailto:bug-ncurses-request@gnu.org">bug-ncurses-request@gnu.org</a>
   </blockquote>
   containing the line:
-
   <blockquote>
     <p><code>subscribe</code>
     <em>&lt;name&gt;@&lt;host.domain&gt;</em></p>
@@ -2040,7 +1617,7 @@ diff --git a/st.info b/st.info
 
   <blockquote>
     <p><a href=
-    "ftp://ftp.invisible-island.net/ncurses/current/">ftp://ftp.invisible-island.net/ncurses/current/</a>
+    "https://invisible-island.net/archives/ncurses/current/">https://invisible-island.net/archives/ncurses/current/</a>
     and<br>
     <a href=
     "https://invisible-mirror.net/archives/ncurses/current/">https://invisible-mirror.net/archives/ncurses/current/</a>&nbsp;.</p>
@@ -2050,19 +1627,17 @@ diff --git a/st.info b/st.info
 
   <blockquote>
     <p><a href=
-    "ftp://ftp.invisible-island.net/ncurses/6.1/">ftp://ftp.invisible-island.net/ncurses/6.1/</a>
+    "https://invisible-island.net/archives/ncurses/6.4/">https://invisible-island.net/archives/ncurses/6.4/</a>
     and<br>
     <a href=
-    "https://invisible-mirror.net/archives/ncurses/6.1/">https://invisible-mirror.net/archives/ncurses/6.1/</a>&nbsp;.</p>
+    "https://invisible-mirror.net/archives/ncurses/6.4/">https://invisible-mirror.net/archives/ncurses/6.4/</a>&nbsp;.</p>
   </blockquote>
 
   <p>There is an archive of the mailing list here:</p>
 
   <blockquote>
     <p><a href=
-    "http://lists.gnu.org/archive/html/bug-ncurses">http://lists.gnu.org/archive/html/bug-ncurses</a>
-    (also <a href=
-    "https://lists.gnu.org/archive/html/bug-ncurses">https</a>)</p>
+    "https://lists.gnu.org/archive/html/bug-ncurses">https://lists.gnu.org/archive/html/bug-ncurses</a>&nbsp;.</p>
   </blockquote>
 
   <h2><a name="h2-this-stuff" id="h2-this-stuff">Related
@@ -2082,6 +1657,9 @@ diff --git a/st.info b/st.info
     <span class="main-name">ncurses</span> versus <span class=
     "main-name">slang</span> (S-Lang)</a></li>
 
+    <li><a href="@HOMEPAGE@/ncurses-openbsd.html">Comments on
+    <span class="main-name">OpenBSD</span></a></li>
+
     <li><a href="@HOMEPAGE@/tack.html">tack &ndash; terminfo action
     checker</a></li>
 
@@ -2101,14 +1679,15 @@ diff --git a/st.info b/st.info
   <a href="http://www.catb.org/~esr/terminfo/">Eric
   Raymond</a>&nbsp;. Unlike the older version, the termcap and
   terminfo data are provided in the same file, which also provides
-  several user-definable extensions beyond the X/Open
+  several user-definable extensions beyond the X/Open Curses
   specification.</p>
 
   <p>You can find lots of information on terminal-related topics
-  not covered in the terminfo file at <a href=
-  "http://web.archive.org/web/*/http://www.cs.utk.edu/~shuford/terminal">
-  Richard Shuford's archive</a>&nbsp;. The collection of computer
-  manuals at <a href=
+  not covered in the terminfo file in <a href=
+  "https://shuford.invisible-island.net/">Richard Shuford's
+  archive</a> (<a href=
+  "http://web.archive.org/web/*/http://www.cs.utk.edu/~shuford/terminal">original</a>).
+  The collection of computer manuals at <a href=
   "http://www.bitsavers.org/pdf/">bitsavers.org</a> has also been
   useful.</p>
 
@@ -2118,11 +1697,9 @@ diff --git a/st.info b/st.info
 
       <li>
         <a href="#h2-release-notes">Release Notes</a>
-
         <ul>
           <li>
             <a href="#h3-library">Library improvements</a>
-
             <ul>
               <li><a href="#h4-new-library">New features</a></li>
 
@@ -2133,7 +1710,6 @@ diff --git a/st.info b/st.info
 
           <li>
             <a href="#h3-programs">Program improvements</a>
-
             <ul>
               <li><a href="#h4-utilities">Utilities</a></li>
 
@@ -2149,7 +1725,6 @@ diff --git a/st.info b/st.info
 
           <li>
             <a href="#h3-config-config">Configuration changes</a>
-
             <ul>
               <li><a href="#h4-config-major">Major changes</a></li>
 
